Autor Tema: DNSblemas (SOLUCIONADO)  (Leído 8433 veces)

Desconectado klondike

  • Iniciado
  • *****
  • Mensajes: 1643
  • Sysadmin a su servicio
    • Xisco's page
Re: DNSblemas
« Respuesta #10 en: 19 de Febrero de 2006, 07:22:53 pm »
de hecho tengo que tener el script de arriba activado para uqe no me lo modifique cada dos por 3

Desconectado goldfinger

  • Pro Member
  • ****
  • Mensajes: 606
  • Where there's a will there's a way
    • Das Reboot
Re: DNSblemas
« Respuesta #11 en: 19 de Febrero de 2006, 08:13:50 pm »
Prueba a editar /etc/dhcp3/dhclient.conf para forzar las DNS locales

Desconectado rnaveiras

  • Member
  • ***
  • Mensajes: 161
Re: DNSblemas
« Respuesta #12 en: 23 de Febrero de 2006, 12:43:24 am »
buenas, al grano que ahi prisa :P

Tanto en dhcp3-client como en dhcp-client, tienes un script en /etc/dhclient-script (al menos en debian y ubuntu esta ahí) , que es el cabrón que te esta machacando el /etc/resolv.conf cada vez que el cliente dhcp considera oportuno.

El /etc/dhclient-script es un script en bash, la función que te jode es make_resolv_conf() , buscalá y cambia el código, pues hacer algo así

Código original

make_resolv_conf() {
  if [ "x$new_domain_name" != x ] && [ x"$new_domain_name_servers" != x ]; then
    echo search $new_domain_name >/etc/resolv.conf
    chmod 644 /etc/resolv.conf
    for nameserver in $new_domain_name_servers; do
      echo nameserver $nameserver >>/etc/resolv.conf
    done
  fi
}

Posible cambio, para solucionar tus problemas

make_resolv_conf() {
  if [ "x$new_domain_name" != x ] && [ x"$new_domain_name_servers" != x ]; then
    echo search $new_domain_name > /dev/null
    chmod 644 /etc/resolv.conf
    for nameserver in $new_domain_name_servers; do
      echo nameserver $nameserver >> /dev/null   
    done
  fi
}


Bueno, pos a disfrutarlo,  :dabo:

Un Saludo.
raul naveiras
/dev/null the ultimate in secure storage.

Desconectado klondike

  • Iniciado
  • *****
  • Mensajes: 1643
  • Sysadmin a su servicio
    • Xisco's page
Re: DNSblemas
« Respuesta #13 en: 23 de Febrero de 2006, 12:50:17 am »
probaré a ver.

Que la prisa sea pasajera ;-)

Desconectado klondike

  • Iniciado
  • *****
  • Mensajes: 1643
  • Sysadmin a su servicio
    • Xisco's page
Re: DNSblemas
« Respuesta #14 en: 12 de Marzo de 2006, 04:19:20 pm »
Pues na que no hay manera, os dejo el script porque yo no lo entiendo  :-(

Código: [Seleccionar]
#!/bin/bash

# dhclient-script for Linux. Dan Halbert, March, 1997.
# Updated for Linux 2.[12] by Brian J. Murrell, January 1999.
# Modified for Debian.  Matt Zimmerman and Eloy Paris, December 2003
# Modified to remove useless tests for antiquated kernel versions that
# this doesn't even work with anyway, and introduces a dependency on /usr
# being mounted, which causes cosmetic errors on hosts that NFS mount /usr
# Andrew Pollock, February 2005
# Modified to work on point-to-point links. Andrew Pollock, June 2005

# The alias handling in here probably still sucks. -mdz

if [ -n "${dhc_dbus}" ]; then
   /usr/bin/dbus-send \
       --system \
       --dest=com.redhat.dhcp \
       --type=method_call \
       /com/redhat/dhcp/$interface \
       com.redhat.dhcp.set \
       'string:'"`env | /bin/egrep -v '^(PATH|SHLVL|_|PWD|dhc_dbus)\='`";
       if (( ( dhc_dbus & 31 ) == 31 )); then
           exit 0;
       fi;
fi;

make_resolv_conf() {
    if [ -n "$new_domain_name" -o -n "$new_domain_name_servers" ]; then
        local new_resolv_conf=/etc/resolv.conf.dhclient-new
        rm -f $new_resolv_conf

        if [ -n "$new_domain_name" ]; then
            echo search $new_domain_name >> $new_resolv_conf
        else # keep 'old' search/domain scope
            egrep -i '^ *[:space:]*(search|domain)' /etc/resolv.conf >> \
                  $new_resolv_conf
        fi
       
        if [ -n "$new_domain_name_servers" ]; then
            for nameserver in $new_domain_name_servers; do
                echo nameserver $nameserver >>$new_resolv_conf
            done
        else # keep 'old' nameservers
            egrep -i '^ *[:space:]*nameserver' /etc/resolv.conf >> \
                  $new_resolv_conf
        fi

        chown --reference=/etc/resolv.conf $new_resolv_conf
        chmod --reference=/etc/resolv.conf $new_resolv_conf
        mv $new_resolv_conf /etc/resolv.conf
    fi
}

run_hook() {
    local script="$1"
    local exit_status

    if [ -f $script ]; then
        . $script
    fi


    if [ -n "$exit_status" ] && [ "$exit_status" -ne 0 ]; then
        logger -p daemon.err "$script returned non-zero exit status $exit_status"
        save_exit_status=$exit_status
    fi

    return $exit_status
}

run_hookdir() {
    local dir="$1"
    local exit_status

    if [ -d "$dir" ]; then
        for script in $(run-parts --list $dir); do
            run_hook $script || true
            exit_status=$?
        done
    fi

    return $exit_status
}

# Must be used on exit.   Invokes the local dhcp client exit hooks, if any.
exit_with_hooks() {
    exit_status=$1

    # Source the documented exit-hook script, if it exists
    if ! run_hook /etc/dhcp3/dhclient-exit-hooks; then
        exit_status=$?
    fi

    # Now run scripts in the Debian-specific directory.
    if ! run_hookdir /etc/dhcp3/dhclient-exit-hooks.d; then
        exit_status=$?
    fi

    exit $exit_status
}

set_hostname() {
    local current_hostname=$(hostname)
    if [ -z "$current_hostname" -o "$current_hostname" = "(none)" ]; then
        hostname "$new_host_name"
    fi
}

if [ -n "$new_broadcast_address" ]; then
    new_broadcast_arg="broadcast $new_broadcast_address"
fi
if [ -n "$old_broadcast_address" ]; then
    old_broadcast_arg="broadcast $old_broadcast_address"
fi
if [ -n "$new_subnet_mask" ]; then
    new_subnet_arg="netmask $new_subnet_mask"
fi
if [ -n "$old_subnet_mask" ]; then
    old_subnet_arg="netmask $old_subnet_mask"
fi
if [ -n "$alias_subnet_mask" ]; then
    alias_subnet_arg="netmask $alias_subnet_mask"
fi
if [ -n "$new_interface_mtu" ]; then
    mtu_arg="mtu $new_interface_mtu"
fi
if [ -n "$IF_METRIC" ]; then
    metric_arg="metric $IF_METRIC" # interfaces(5), "metric" option
fi


# The action starts here

# Invoke the local dhcp client enter hooks, if they exist.
run_hook /etc/dhcp3/dhclient-enter-hooks
run_hookdir /etc/dhcp3/dhclient-enter-hooks.d

# Execute the operation
case "$reason" in
    MEDIUM|ARPCHECK|ARPSEND)
        # Do nothing
        ;;
    PREINIT)
        # The DHCP client is requesting that an interface be
        # configured as required in order to send packets prior to
        # receiving an actual address. - dhclient-script(8)

        if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 2 ) != 2 )); then
         if [ -n "$alias_ip_address" ]; then
            # Bring down alias interface. Its routes will disappear too.
            ifconfig $interface:0- inet 0
         fi
         ifconfig $interface 0 up
        fi
        ;;
    BOUND|RENEW|REBIND|REBOOT)

        set_hostname
       
        if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 2 ) != 2 )); then
         if [ -n "$old_ip_address" -a -n "$alias_ip_address" -a \
             "$alias_ip_address" != "$old_ip_address" ]; then
            # Possible new alias. Remove old alias.
            ifconfig $interface:0- inet 0
         fi

         if [ -n "$old_ip_address" -a \
             "$old_ip_address" != "$new_ip_address" ]; then
            # IP address changed. Bringing down the interface will delete all routes,
            # and clear the ARP cache.
            ifconfig $interface inet 0 down

         fi
        fi

        if [ -z "$old_ip_address" -o "$old_ip_address" != "$new_ip_address" -o \
            "$reason" = "BOUND" -o "$reason" = "REBOOT" ]; then
          if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 2 ) != 2 )); then
            ifconfig $interface inet $new_ip_address $new_subnet_arg \
                $new_broadcast_arg $mtu_arg
          fi
         
          if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 4 ) != 4 )); then
            for router in $new_routers; do
                route add default dev $interface gw $router $metric_arg
            done
          fi
        fi

       
       if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 2 ) != 2 )); then
        if [ "$new_ip_address" != "$alias_ip_address" -a -n "$alias_ip_address" ];
            then
            ifconfig $interface:0- inet 0
            ifconfig $interface:0 inet $alias_ip_address $alias_subnet_arg
            route add -host $alias_ip_address $interface:0
         fi
        fi
       
       if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 1 ) != 1 )); then
        make_resolv_conf
       fi

        ;;

    EXPIRE|FAIL|RELEASE|STOP)
        if [ -n "$alias_ip_address" ]; then
            # Turn off alias interface.
            ifconfig $interface:0- inet 0
        fi

        if [ -n "$old_ip_address" ]; then
            # Shut down interface, which will delete routes and clear arp cache.
            ifconfig $interface inet 0 down
        fi

        if [ -n "$alias_ip_address" ]; then
            ifconfig $interface:0 inet $alias_ip_address $alias_subnet_arg
            route add -host $alias_ip_address $interface:0
        fi

        ;;

    TIMEOUT)
       if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 2 ) != 2 )); then
        if [ -n "$alias_ip_address" ]; then
            ifconfig $interface:0- inet 0
        fi

        ifconfig $interface inet $new_ip_address $new_subnet_arg \
            $new_broadcast_arg $mtu_arg
       fi

        set -- $new_routers
        first_router="$1"

        if ping -q -c 1 $first_router; then
         if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 2 ) != 2 )); then
            if [ "$new_ip_address" != "$alias_ip_address" -a \
                -n "$alias_ip_address" ]; then
                ifconfig $interface:0 inet $alias_ip_address $alias_subnet_arg
                route add -host $alias_ip_address dev $interface:0
            fi
         fi

         # point to point
         if [ "$new_subnet_mask" == "255.255.255.255" ]; then
             for router in $new_routers; do
                 route add -host $router dev $interface
             done
         fi

         if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 4 ) != 4 )); then
            for router in $new_routers; do
                route add default dev $interface gw $router $metric_arg
            done
         fi

         if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 1 ) != 1 )); then
            make_resolv_conf
         fi
        else
            # Changed from 'ifconfig $interface inet 0 down' - see Debian bug #144666
          if [ -z "${dhc_dbus}" ] || (( ( dhc_dbus & 2 ) != 2 )); then
            ifconfig $interface inet 0
          fi
            exit_with_hooks 2
        fi

        ;;
esac

exit_with_hooks 0

Desconectado rnaveiras

  • Member
  • ***
  • Mensajes: 161
Re: DNSblemas
« Respuesta #15 en: 12 de Marzo de 2006, 04:49:51 pm »
Bueno el script de tu dhclient es distinto al de debian o ubuntu, pero básicamente es el mismo problema.

Si te fijas en la función make_resolv_conf() ,  en la variable new_resolv_conf, se crea  lo que será el futuro nuevo fichero resolv.conf y luego al final se sobrescribe tu fichero /etc/resolv.conf con el nuevo. Para evitar esto solo tienes que cambiar la siguiente linea.

Código original
 mv $new_resolv_conf /etc/resolv.conf

Código nuevo
 mv $new_resolv_conf /etc/resolv.conf.dhcp

De esta forma, simplemente, tu cliente dchp te crear el fichero /etc/resolv.conf.dhcp y en tu fichero /etc/resolv.conf tendrás la información estática que tu configures y no sera reescrito por el cliente dhcp.

Un Saludo.. :)

raul naveiras
/dev/null the ultimate in secure storage.

Desconectado klondike

  • Iniciado
  • *****
  • Mensajes: 1643
  • Sysadmin a su servicio
    • Xisco's page
Re: DNSblemas
« Respuesta #16 en: 05 de Abril de 2006, 10:05:55 pm »
Al fin, muchas gracias Raúl.

El retraso  tiene una justificación; sólo puedo trabajar con Linux cuando tengo un poco de tiempo.

Desconectado Liamngls

  • Administrator
  • ******
  • Mensajes: 15599
    • Manuales-e
Re: DNSblemas (SOLUCIONADO)
« Respuesta #17 en: 05 de Abril de 2006, 10:15:02 pm »
Así se hace monstruo , damos el tema por solucionado :-)

Desconectado klondike

  • Iniciado
  • *****
  • Mensajes: 1643
  • Sysadmin a su servicio
    • Xisco's page
Re: DNSblemas (SOLUCIONADO)
« Respuesta #18 en: 05 de Abril de 2006, 10:35:54 pm »
De acuerdo, que ya iba siendo siglo...
(al fin puedo conectarme desde mi Linux :-) )

Desconectado Aj

  • Administrator
  • ******
  • Mensajes: 3612
  • Avatar by Jaleo
    • Mis chorradicas
Re: DNSblemas (SOLUCIONADO)
« Respuesta #19 en: 06 de Abril de 2006, 07:03:18 am »
Veennnga pues....

Cierro tema

 

Aviso Legal | Política de Privacidad | Política de Cookies

el contenido de la web se rige bajo licencia
Creative Commons License